/**
 * Main script for the BonusThemes.com Play & Learn Template
 *
 * @package bt_playlearn
 * @version 1.0
 * @copyright BonusThemes.com 2009
 * @link http://www.bonusthemes.com/goto/bt_playlearn
 */


function bt_add_event(obj, event, func) {
	if (obj.addEventListener)
		obj.addEventListener(event, func, false);
	else if (obj.attachEvent)
		obj.attachEvent('on' + event, func);
}


// CMenu handlers

function playlearn_ch_create(mi) {
	if (mi.is_header)
		mi.wdg.style.cursor = 'pointer';
}

function playlearn_ch_mouseover(mi) {
	if (document.page_loaded && mi.is_header) {
		mi.panel_ch_x = -1; //wdg.left.offsetWidth;
		mi.panel_ch_y = mi.wdg.offsetHeight + 1;

		var obj = mi.wdg;
		mi.panel_ch_x += obj.offsetLeft;
		obj = obj.offsetParent;
		while (obj) {
			mi.panel_ch_x += obj.offsetLeft;
			mi.panel_ch_y += obj.offsetTop;
			obj = obj.offsetParent;
		}
		mi.panel_ch_min_w = mi.wdg.offsetWidth + 2;

		if (typeof mi.td_class == 'undefined')
			mi.td_class = mi.wdg.className;

		mi.wdg.className = 'cmenu_hd_sel';
	}
}

function playlearn_menu_close(mi) {
	if (document.page_loaded && typeof mi.td_class != 'undefined')
		mi.wdg.className = mi.td_class;
}

function playlearn_ch_mouseout(mi) {
	if (mi.is_header && mi.menuitems.length == 0)
		playlearn_menu_close(mi);
}

function playlearn_ch_panel_hide(mi) {
	if (mi.is_header)
		playlearn_menu_close(mi);
}


// window handlers

window_w = 0;
window_h = 0;
function playlearn_h_resize()
{
	var w = 0, h = 0;
	if (window.innerWidth) {
		w = window.innerWidth;
		h = window.innerHeight;
	}
	else if (document.documentElement && document.documentElement.clientWidth) {
		w = document.documentElement.clientWidth;
		h = document.documentElement.clientHeight;
	}
	else if (document.body && document.body.clientWidth) {
		w = document.body.clientWidth;
		h = document.body.clientHeight;
	}

	if (window_w != w || window_h != h) {
		window_w = w;
		window_h = h;

		if (document['ext_top'])
			document['ext_top'].set_position();

		if (document['ext_display'])
			document['ext_display'].set_position();
	}
}
bt_add_event(window, 'resize', playlearn_h_resize);


// page initialization

function playlearn_page_init() {
	document.page_loaded = true;

	document['ext_top'] = new ExtTop('top_area', 'ext_top', 'top');

	document['ext_display'] = new ExtDisplay('display_area', 'ext_display', 'display');
	document['ext_display'].h_click('ext_display_node_0');

	if (document['cmenu_items']) {
		document['mc'] = new CMenu({
			iname: 'mc',

			edge_min: 'upper_area',

			side: 'down',
			orientation: 'right',

			animate: true,
			anim_step: 10,
			anim_interval: 30,

			transparency: true,
			transparency_ie6: false,

			min_opacity: 0,
			max_opacity: 100,

			ch_create: playlearn_ch_create,
			ch_mouseover: playlearn_ch_mouseover,
			ch_mouseout: playlearn_ch_mouseout,
			ch_panel_hide: playlearn_ch_panel_hide,

			panel_offset1_x: 0,
			panel_offset1_y: 0,
			panel_offset2_x: 7,
			panel_offset2_y: 0,

			itemborder_class: 'cmenu_itemborder',
			separator_class: 'cmenu_separator',
			panel_class: 'cmenu_panel',
			panel_tl_class: 'cmenu_tl',
			panel_tc_class: 'cmenu_tc',
			panel_tr_class: 'cmenu_tr',
			panel_ml_class: 'cmenu_ml',
			panel_mr_class: 'cmenu_mr',
			panel_bl_class: 'cmenu_bl',
			panel_bc_class: 'cmenu_bc',
			panel_br_class: 'cmenu_br',

			mi_empty_normal_class: 'cmenu_mi_empty_normal',
			mi_empty_hover_class: 'cmenu_mi_empty_hover',
			mi_full_normal_class: 'cmenu_mi_full_normal',
			mi_full_hover_class: 'cmenu_mi_full_hover'

		});

		var len = document['cmenu_items'].length;
		if (len > 0) {
			for (var i = 0; i < len; i++) {
				var item = document['cmenu_items'][i];

				if (typeof item.parent_id == 'undefined')
					this[item.id] = document['mc'].add_item(item);
				else
					this[item.id] = this[item.parent_id].add_item(item);
			}
		
			document['mc'].run();
		}
	}
}

bt_add_event(window, 'load', playlearn_page_init);


var goto_top_type = -1;
var goto_top_itv = 0;

function goto_top_timer() {
	var y = goto_top_type == 1 ? document.documentElement.scrollTop : document.body.scrollTop;
	var moveby = 15;

	y -= Math.ceil(y * moveby / 100);
	if (y < 0)
		y = 0;

	if (goto_top_type == 1)
		document.documentElement.scrollTop = y;
	else
		document.body.scrollTop = y;

	if (y == 0) {
		clearInterval(goto_top_itv);
		goto_top_itv = 0;
	}
}

function goto_top() {
	if (goto_top_itv == 0) {
		if (document.documentElement && document.documentElement.scrollTop)
			goto_top_type = 1;
		else if (document.body && document.body.scrollTop)
			goto_top_type = 2;
		else
			goto_top_type = 0;

		if (goto_top_type > 0)
			goto_top_itv = setInterval('goto_top_timer()', 50);
	}
}

